Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/Codes.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/Codes.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/Codes.java	(revision 44738)
@@ -1,5 +1,6 @@
 package org.gvsig.expressionevaluator;
 
+import org.gvsig.tools.util.GetItemByKey;
 import org.gvsig.tools.util.UnmodifiableBasicList;
 import org.gvsig.tools.visitor.Visitable;
 
@@ -7,6 +8,14 @@
  *
  * @author jjdelcerro
  */
-public interface Codes extends Code, Visitable, UnmodifiableBasicList<Code> {
+public interface Codes extends Code, Visitable, UnmodifiableBasicList<Code>, GetItemByKey<String,Code> {
 
+  public boolean useArgNames();
+  
+  public boolean useArgNames(boolean useNames);
+  
+  public boolean contains(String name, int index);
+  
+  public String getName(int index);
+  
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/Statement.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/Statement.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/Statement.java	(revision 44738)
@@ -32,6 +32,7 @@
         
         public boolean isReservedWord(String s);
 
+        public void trace(String msg);
     }
 
     public interface Rule {
@@ -50,6 +51,11 @@
 
         public ConditionalRule addRuleOnFalse(Rule rule);
     }
+    
+    public interface SwichTokenRule extends Rule {
+        public SwichTokenRule addCase(String token, Rule... rules);
+        public SwichTokenRule addDefault(Rule... rules);
+    }   
 
     public interface ArgsBuilder {
 
@@ -74,6 +80,8 @@
 
     public CompoundRule repeat_until_any_tokens(String... token);
 
+    public CompoundRule repeat();
+
     public Rule require_identifier(String id);
 
     public Rule require_literal_string(String id);
@@ -84,6 +92,10 @@
 
     public Rule require_expressions(String id, String separator);
 
+    public Rule break_loop();
+    
+    public SwichTokenRule switch_token();
+
     public ConditionalRule optional_any_token(String... id);
 
     public ConditionalRule optional_identifiers(String id, String separator);
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/spi/AbstractFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/spi/AbstractFunction.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/spi/AbstractFunction.java	(revision 44738)
@@ -131,6 +131,11 @@
     }
 
     @Override
+    public boolean isHidden() {
+      return false;
+    }
+    
+    @Override
     public boolean useArgumentsInsteadObjects() {
         return false;
     }
@@ -144,6 +149,11 @@
     public boolean allowConstantFolding() {
         return false;
     }
+
+    @Override
+    public boolean allowArgNames() {
+      return false;
+    }
     
     @Override
     public Object call(Interpreter interpreter, Codes args) throws Exception {
@@ -259,6 +269,24 @@
         return value;
     }
     
+    protected Object getObject(Interpreter interpreter, Codes args, String name) {
+        Code arg = args.get(name);
+        if( arg==null ) {
+            return null;
+        }
+        Object value = interpreter.run(arg);
+        return value;
+    }
+    
+    protected Object getObject(Interpreter interpreter, Codes args, String name, int index) {
+        Code arg = args.get(name+index);
+        if( arg==null ) {
+            return null;
+        }
+        Object value = interpreter.run(arg);
+        return value;
+    }
+    
     protected Date getDate(Object[] args, int n) {
         if( args.length < n  ) {
             throw new IllegalArgumentException(I18N.Required_argument_XargnX_and_only_found_XargcX_in_call_to_XIdentifierX(name(), args.length, n));
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/spi/AbstractLexicalAnalyzer.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/spi/AbstractLexicalAnalyzer.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/spi/AbstractLexicalAnalyzer.java	(revision 44738)
@@ -204,11 +204,11 @@
 
     abstract protected Token getToken();
 
-    protected void push_state() {
+    public void push_state() {
         this.states.push(position);
     }
 
-    protected void pop_state() {
+    public void pop_state() {
         position = this.states.pop();
     }
 
@@ -511,4 +511,13 @@
     public boolean getUseBracketsForIdentifiers() {
         return this.useBracketsForIdentifiers;
     }
+    
+    public String getSourceContext() {
+        String s = StringUtils.left(source, position) + "[*]" + StringUtils.mid(source, position, 200);
+        if( s.length()>200 ) {
+            s = "..."+StringUtils.mid(s, position-100, 200)+"...";
+        }
+        return s;
+    }      
+    
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/Function.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/Function.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/Function.java	(revision 44738)
@@ -39,6 +39,8 @@
     
     public boolean isOperator();
     
+    public boolean isHidden();
+    
     public boolean useArgumentsInsteadObjects();
     
     public boolean isSQLCompatible();
@@ -53,4 +55,6 @@
      * @return true if this function allow constant folding optimization.
      */
     public boolean allowConstantFolding();
+    
+    public boolean allowArgNames();
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/LexicalAnalyzer.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/LexicalAnalyzer.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/LexicalAnalyzer.java	(revision 44738)
@@ -86,4 +86,6 @@
     public void setUseBracketsForIdentifiers(boolean useBracketsForIdentifiers);
     
     public boolean getUseBracketsForIdentifiers();
+    
+    public String getSourceContext(); 
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestGrammarCompiler.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestGrammarCompiler.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestGrammarCompiler.java	(revision 44738)
@@ -62,6 +62,10 @@
         interpreter.setSymbolTable(symbolTable);
         return interpreter;
     }
+    
+    private void link(Code code) {
+      code.link(createSymbolTable());
+    }
 
     public void testLet() {
         String source = "LET V1 = 23";
@@ -96,6 +100,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
+        link(code);
         assertEquals("BLOCK(LET('V1', 11), LET('V2', 22))", code.toString());
     }
 
@@ -105,6 +110,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
+        link(code);
         assertEquals("BLOCK_EXCEPT(LET('V1', 11), LET('V2', 22), -1)", code.toString());
     }
 
@@ -113,10 +119,12 @@
 
         String source = "BEGIN LET V1 = 11; LET V2 = 22;  END";
         Code code = compiler.compileExpression(source);
+        link(code);
         assertEquals("BLOCK(LET('V1', 11), LET('V2', 22))", code.toString());
 
         source = "BEGIN LET V1 = 11;; LET V2 = 22;;;  END";
         code = compiler.compileExpression(source);
+        link(code);
         assertEquals("BLOCK(LET('V1', 11), LET('V2', 22))", code.toString());
     }
 
@@ -126,6 +134,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
+        link(code);
         assertEquals("IFF((\"V1\" = 11), LET('V2', 22))", code.toString());
     }
 
@@ -135,6 +144,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
+        link(code);
         assertEquals("IFF((\"V1\" = 11), LET('V2', 11), LET('V2', 22))", code.toString());
     }
 
@@ -144,6 +154,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
+        link(code);
         assertEquals("IFF((\"V1\" = 11), BLOCK(LET('V2', 22), LET('V1', 10)))", code.toString());
     }
 
@@ -153,6 +164,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
+        link(code);
         assertEquals("WHILE((\"n\" < 10), LET('n', (\"n\" + 1)))", code.toString());
     }
 
@@ -162,6 +174,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
+        link(code);
         assertEquals("WHILE((\"n\" < 10), BLOCK(LET('n', (\"n\" + 1)), print(\"n\")))", code.toString());
     }
 
@@ -171,6 +184,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
+        link(code);
         assertEquals("CAST(\"V1\", 'INTEGER')", code.toString());
     }
 
@@ -180,6 +194,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
+        link(code);
         assertEquals("CAST(\"V1\", 'INTEGER')", code.toString());
     }
 
@@ -190,14 +205,17 @@
 
         source = "MATCH 'Hola', '[Hh]ola'";
         code = compiler.compileExpression(source);
+        link(code);
         assertEquals("~('Hola', '[Hh]ola')", code.toString());
 
         source = "MATCH 'Hola' '[Hh]ola'";
         code = compiler.compileExpression(source);
+        link(code);
         assertEquals("~('Hola', '[Hh]ola')", code.toString());
 
         source = "MATCH('Hola', '[Hh]ola')";
         code = compiler.compileExpression(source);
+        link(code);
         assertEquals("~('Hola', '[Hh]ola')", code.toString());
     }
 
@@ -207,6 +225,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
+        link(code);
         assertEquals("FOREACH('n', RANGE(10), print(\"n\"))", code.toString());
     }
 
@@ -225,6 +244,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
+        link(code);
         assertEquals("CASE((\"software\" LIKE '%gvSIG%'), 'gvSIG', 'Other')", code.toString());
     }
 
@@ -234,6 +254,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
+        link(code);
         assertEquals("CASE((\"software\" LIKE '%gvSIG%'), 'gvSIG', 'Other')", code.toString());
     }
 
@@ -243,6 +264,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
+        link(code);
         assertEquals("CASE(((\"Field_1\" >= 75) AND (\"Field_1\" <= 79)), ((\"Field_1\" >= 80) AND (\"Field_1\" <= 84)), 100, 110)", code.toString());
     }
     
@@ -252,6 +274,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
+        link(code);
         assertEquals("CASE(((\"Field_1\" >= 75) AND (\"Field_1\" <= 79)), ((\"Field_1\" >= 80) AND (\"Field_1\" <= 84)), 100, 110, 120)", code.toString());
     }
     
@@ -261,7 +284,9 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("CREATE_FUNCTION('test1', print('Hola'))", code.toString());
+        link(code);
+        assertEquals("CREATE_FUNCTION(FUNCTION_NAME:'test1', BODY:print('Hola'))", code.toString());
+                     
     }
     
     public void testDef2() {
@@ -270,7 +295,8 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("CREATE_FUNCTION('test1', LIST('nombre'), print(('Hola ' + \"nombre\")))", code.toString());
+        link(code);
+        assertEquals("CREATE_FUNCTION(FUNCTION_NAME:'test1', PARAMETERS:LIST('nombre'), BODY:print(('Hola ' + \"nombre\")))", code.toString());
     }
 
     public void testDef3() {
@@ -279,7 +305,8 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("CREATE_FUNCTION('test1', LIST('nombre'), RETURN(('Hola ' || \"nombre\")))", code.toString());
+        link(code);
+        assertEquals("CREATE_FUNCTION(FUNCTION_NAME:'test1', PARAMETERS:LIST('nombre'), BODY:RETURN(('Hola ' || \"nombre\")))", code.toString());
     }
     
     public void testCreateFunctionExtern1() {
@@ -288,7 +315,8 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("CREATE_FUNCTION('test1', LIST('nombre'), 'addons/test/test', 'test1', 'cosa')", code.toString());
+        link(code);
+        assertEquals("CREATE_FUNCTION(FUNCTION_NAME:'test1', PARAMETERS:LIST('nombre'), SCRIPT_PATH:'addons/test/test', SCRIPT_FUNCTION:'test1', LANGUAGE:'cosa')", code.toString());
     }
     
     public void testList() {
@@ -297,16 +325,28 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
+        link(code);
         assertEquals("LET('x', LIST('hola', 'adios', 'fin'))", code.toString());
     }
     
+    public void testTuple() {
+        String source = "set x TO TUPLE('hola','adios','fin')";
+
+        Compiler compiler = createCompiler();
+
+        Code code = compiler.compileExpression(source);
+        link(code);
+        assertEquals("LET('x', TUPLE('hola', 'adios', 'fin'))", code.toString());
+    }
+    
     public void testArray() {
-        String source = "set x TO ARRAY['hola','adios','fin']";
+        String source = "set x TO ARRAY('hola','adios','fin')";
 
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("LET('x', LIST('hola', 'adios', 'fin'))", code.toString());
+        link(code);
+        assertEquals("LET('x', ARRAY('hola', 'adios', 'fin'))", code.toString());
     }
     
     public void testUseCase1() {
@@ -315,6 +355,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
+        link(code);
         assertEquals("BLOCK(LET('x', ''), FOREACH('n', list('hola', 'adios', 'fin'), LET('x', ((\"x\" || ' ') || \"n\"))))", code.toString());
     }
 
@@ -324,6 +365,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
+        link(code);
         assertEquals("BLOCK(LET('s', ''), LET('x', LIST('hola', 'adios', 'fin')), FOREACH('n', RANGE(3), LET('s', ((\"s\" || ' ') || GETITEM(\"x\", \"n\")))))", code.toString());
     }
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultCompiler.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultCompiler.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultCompiler.java	(revision 44738)
@@ -18,9 +18,14 @@
 import org.gvsig.expressionevaluator.impl.DefaultCodeBuilder.BaseConstant;
 import org.gvsig.expressionevaluator.impl.function.operator.NegOperator;
 import org.gvsig.expressionevaluator.impl.function.programming.CodeBlockFunction;
+import org.gvsig.expressionevaluator.spi.AbstractLexicalAnalyzer;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
 
 public class DefaultCompiler implements Compiler {
 
+    protected static final Logger LOGGER = LoggerFactory.getLogger(DefaultCompiler.class);
+    
     class DefaultStatementContext implements StatementContext {
 
         private String codeClassifier;
@@ -89,9 +94,15 @@
             return DefaultCompiler.this.parse_expressions(separator);
         }
         
+        @Override
         public boolean isReservedWord(String s) {
             return grammars.isReservedWord(s);
         }
+        
+        @Override
+        public void trace(String msg) {
+//          System.out.println(msg+". "+this.getLexicalAnalyzer().getSourceContext());
+        } 
     }
 
     private boolean objectAccessSupported;
@@ -504,7 +515,7 @@
                 Token next = lexer.look();
                 if( next.getType() == Token.PARENTHESIS_OPEN ) {
                     lexer.next();
-                    Codes args = parse_expressions(",");
+                    Codes args = parse_arguments();
                     next = lexer.next();
                     switch(next.getType()) {
                         case Token.PARENTHESIS_CLOSE:
@@ -592,6 +603,40 @@
         }
     }
 
+    public Codes parse_arguments() {
+        String sep = ",";
+        BaseCodes codes = null;
+        while( true ) {
+            ((AbstractLexicalAnalyzer)lexer).push_state();
+            String argName = null;
+            Token tok0 = lexer.next();
+            Token tok1 = lexer.next();
+            if( tok0.getType()==Token.IDENTIFIER && tok1.is(":") ) {
+              argName = (String) tok0.getValue();
+            } else {
+              ((AbstractLexicalAnalyzer)lexer).pop_state();
+            }
+            Code code = parse_expression();
+            if( code!=null ) {
+                if( codes == null ) {
+                    codes = (BaseCodes) codeBuilder.args();
+                }
+                codes.add(argName, code);
+            }
+            Token next = lexer.look();
+            String literal = next.getLiteral();
+            if( literal == null ) {
+                return codes;
+            }
+            literal = literal.trim();
+            if( sep.equals(literal) ) {
+                lexer.next(); // Consume el ",".
+            } else {
+                return codes;
+            }
+        }
+    }
+
     private Code parse_grammars() {
         StatementContext context = new DefaultStatementContext();
         Code code;
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultCodeBuilder.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultCodeBuilder.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultCodeBuilder.java	(revision 44738)
@@ -5,6 +5,8 @@
 import java.util.Iterator;
 import java.util.List;
 import org.apache.commons.lang3.StringUtils;
+import org.apache.commons.lang3.tuple.ImmutablePair;
+import org.apache.commons.lang3.tuple.Pair;
 import org.gvsig.expressionevaluator.Code;
 import static org.gvsig.expressionevaluator.Code.CALLER;
 import static org.gvsig.expressionevaluator.Code.CONSTANT;
@@ -90,7 +92,9 @@
                 }
                 if( caller.parameters() != null ) {
                     for( Code arg : caller.parameters() ) {
-                        arg.link(symbolTable);
+                        if( arg!=null ) {
+                          arg.link(symbolTable);
+                        }
                     }
                 }
             }
@@ -236,13 +240,26 @@
 
     public class BaseCodes implements Codes {
 
-        private final List<Code> codes;
+        private final List<Pair<String,Code>> codes;
+        private boolean useNames;
 
         public BaseCodes() {
             this.codes = new ArrayList<>();
+            this.useNames = false;
         }
 
         @Override
+        public boolean useArgNames() {
+          return this.useNames;
+        }
+
+        @Override
+        public boolean useArgNames(boolean useNames) {
+          this.useNames = useNames;
+          return this.useNames;
+        }
+        
+        @Override
         public int code() {
             return CODES;
         }
@@ -255,38 +272,83 @@
             return this.codes.size();
         }
 
+        public void add(String name, Code arg) {
+            this.codes.add(new ImmutablePair<>(name, arg));
+        }
+
         public void add(Code arg) {
-            this.codes.add(arg);
+            this.codes.add(new ImmutablePair<>(null, arg));
         }
 
         public void insert(int pos, Code arg) {
-            this.codes.add(pos, arg);
+            this.codes.add(pos, new ImmutablePair<>(null, arg));
         }
 
         @Override
+        public boolean contains(String name, int index) {
+          String argNameX = name + String.valueOf(index).trim();
+          for (Pair<String, Code> arg : this.codes) {
+            if( StringUtils.equalsIgnoreCase(arg.getKey(), argNameX) ) {
+              return true;
+            }
+          }
+          return false;
+        }
+        
+        @Override
         public Iterator<Code> iterator() {
-            return this.codes.iterator();
+          final Iterator<Pair<String, Code>> it = this.codes.iterator();
+          return new Iterator<Code>() {
+            @Override
+            public boolean hasNext() {
+              return it.hasNext();
+            }
+
+            @Override
+            public Code next() {
+              Pair<String, Code> arg = it.next();
+              return arg.getValue();
+            }
+          };
         }
 
         @Override
         public Code get(int n) {
-            return this.codes.get(n);
+            return this.codes.get(n).getValue();
         }
 
         @Override
+        public Code get(String name) {
+          for (Pair<String, Code> arg : this.codes) {
+            if( StringUtils.equalsIgnoreCase(name, arg.getKey()) ) {
+              return arg.getValue();
+            }
+          }
+          return null;
+        }
+
+        public String getName(int n) {
+            return this.codes.get(n).getKey();
+        }
+
+        @Override
         public boolean isEmpty() {
             return this.codes.isEmpty();
         }
 
         @Override
         public List<Code> toList() {
-            return Collections.unmodifiableList(this.codes);
+            List<Code> l = new ArrayList<>();
+            for (Pair<String, Code> arg : this.codes) {
+              l.add(arg.getValue());
+            }
+            return Collections.unmodifiableList(l);
         }
 
         @Override
         public void accept(Visitor visitor) throws BaseException {
-            for( Code arg : this.codes ) {
-                arg.accept(visitor);
+            for( Pair<String,Code> arg : this.codes ) {
+                arg.getValue().accept(visitor);
             }
         }
 
@@ -313,7 +375,12 @@
             if( codes != null ) {
                 StringBuilder builder = new StringBuilder();
                 boolean skipcoma = true;
-                for( Code code : codes ) {
+                for( Pair<String, Code> arg : codes ) {
+                    if( arg == null ) {
+                      continue;
+                    }
+                    String name = arg.getKey();
+                    Code code = arg.getValue();
                     if( code == null ) {
                         continue;
                     }
@@ -322,7 +389,13 @@
                     } else {
                         builder.append(", ");
                     }
-                    builder.append(code.toString(formatter));
+                    if( name==null || !useNames ) {
+                        builder.append(code.toString(formatter));
+                    } else {
+                        builder.append(name);
+                        builder.append(":");
+                        builder.append(code.toString(formatter));
+                    }
                 }
                 return builder.toString();
             }
@@ -331,8 +404,8 @@
 
         @Override
         public void link(SymbolTable symbolTable) {
-            for (Code code : this.codes) {
-                code.link(symbolTable);
+            for (Pair<String,Code> arg : this.codes) {
+                arg.getValue().link(symbolTable);
             }
         }
 
@@ -377,6 +450,9 @@
         @Override
         public Function function(Function function) {
             this.function = function;
+            if( this.args!=null && this.function!=null ) {
+              this.args.useArgNames(this.function.allowArgNames());
+            }
             return this.function;
         }
 
@@ -472,12 +548,30 @@
                     break;
                 case FUNCTION:
                 default:
-                    builder.append(this.name());
-                    builder.append("(");
-                    if( this.parameters()!=null ) {
-                        builder.append(this.parameters().toString(formatter));
+                    if( StringUtils.equalsIgnoreCase(this.name(),GetattrFunction.NAME) ) {
+                      Code arg0 = this.parameters().get(0);
+                      Code arg1 = this.parameters().get(1);
+                      if( arg0 instanceof Code.Identifier && arg1 instanceof Code.Constant ) {
+                        builder.append(arg0.toString(formatter));
+                        builder.append(".\"");
+                        builder.append(((Code.Constant)arg1).value());
+                        builder.append("\"");
+                      } else {
+                        builder.append(this.name());
+                        builder.append("(");
+                        builder.append(arg0.toString(formatter));
+                        builder.append(", ");
+                        builder.append(arg1.toString(formatter));
+                        builder.append(")");
+                      }
+                    } else {
+                      builder.append(this.name());
+                      builder.append("(");
+                      if( this.parameters()!=null ) {
+                          builder.append(this.parameters().toString(formatter));
+                      }
+                      builder.append(")");
                     }
-                    builder.append(")");
             }
             return builder.toString();
         }
